/* Se da un sir numeric a[1]....a[n]
    Pentru fiecare valoare a[i] din sir, sa se gaseasca
    cea mai apropiata valoare a[j] (j > i) astfel incat
    a[i] < a[j]
*/
#include <fstream>
#include <algorithm>
using namespace std;

ifstream fin("stiva.in");
ofstream fout("stiva.out");

const int Dim = 100000;
int a[Dim], n;
/// in stiva plasam pozitii
int st[Dim], tp;    /// tp = pozitia elementului din varful stivei
int p[Dim];         /// p[i] = j (a[j] este cea mai apropiata valoare din dreapta, mai mare decat a[i])

int main()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
        fin >> a[i];

    /// Complexitate: O(n)
    for (int i = 1; i <= n; ++i)
    {
        /// cat timp stiva nu e vida
        /// si valoarea elementului a carei pozitie e salvata in varful stivei
        /// e mai mica decat valoare curenta a[i]
        while (tp && a[st[tp]] < a[i])
        {
            p[st[tp]] = i;
            tp--;            /// sterg elem din varful stivei
        }
        st[++tp] = i;
    }

    for (int i = 1; i <= n; ++i)
        fout << a[i] << ' ';
    fout << '\n';

    for (int i = 1; i <= n; ++i)
        fout << p[i] << ' ';

    return 0;
}


